import { defineComponent, computed, openBlock, createBlock, resolveDynamicComponent, withCtx, renderSlot, ref, onMounted, watch, h, useSlots, watchEffect, resolveComponent, createElementBlock, createElementVNode, createVNode, createCommentVNode, Transition, withModifiers, normalizeStyle, unref } from "vue";
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "itlab-app-header-button",
  props: {
    href: null,
    routeName: null,
    to: null
  },
  emits: ["click"],
  setup(__props) {
    const route = computed(() => {
      if (__props.to)
        return __props.to;
      if (__props.routeName)
        return { name: __props.routeName };
      return void 0;
    });
    const comp = computed(() => {
      if (route.value)
        return "router-link";
      if (__props.href)
        return "a";
      return "div";
    });
    return (_ctx, _cache) => {
      return openBlock(), createBlock(resolveDynamicComponent(comp.value), {
        class: "itlab-app-header-button",
        to: route.value,
        href: __props.href,
        onClick: _cache[0] || (_cache[0] = ($event) => _ctx.$emit("click", $event))
      }, {
        default: withCtx(() => [
          renderSlot(_ctx.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "href"]);
    };
  }
});
const itlabAppHeaderButton_vue_vue_type_style_index_0_lang = "";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
const propsModel = {
  modelValue: {
    type: Boolean,
    default: false
  },
  duration: {
    type: Number,
    default: 500
  },
  timingFunction: {
    type: String,
    default: "ease-in-out"
  },
  tag: {
    type: String,
    default: "div"
  },
  responsive: {
    type: Boolean,
    default: false
  }
};
var index = {
  emits: ["open-start", "close-start", "open-end", "close-end", "layout-shift"],
  props: __spreadValues({}, propsModel),
  setup(props, { slots, attrs, emit }) {
    const containerRef = ref(null);
    const isInit = ref(false);
    const shouldHideOverflow = ref(false);
    const contentHeight = ref(0);
    const currentHeight = ref(0);
    const isTransitioning = ref(false);
    const transitionDuration = computed(() => {
      return typeof props.duration === "number" ? `${props.duration}ms` : props.duration;
    });
    const delayAction = (fn) => {
      setTimeout(() => {
        window.requestAnimationFrame(fn);
      }, 0);
    };
    const updateContainerHeight = () => {
      containerRef.value ? contentHeight.value = containerRef.value.scrollHeight : "";
    };
    const updateDisplay = () => {
      if (isTransitioning.value === true) {
        if (props.modelValue === false)
          currentHeight.value = 0;
        updateContainerHeight();
        return transitionEnd({ target: containerRef.value });
      }
      currentHeight.value = contentHeight.value + "px";
      if (props.modelValue === false) {
        shouldHideOverflow.value = true;
        emit("close-start");
        delayAction(() => {
          currentHeight.value = 0;
        });
      } else
        emit("open-start");
      isTransitioning.value = true;
    };
    const generatedBaseStyles = computed(() => ({
      transition: isInit.value ? `height ${transitionDuration.value} ${props.timingFunction}` : null,
      height: isInit.value ? currentHeight.value : null,
      overflowY: shouldHideOverflow.value ? "hidden" : null,
      "--content-height": contentHeight.value
    }));
    const generatedBaseAttributes = computed(() => ({
      "aria-hidden": props.modelValue === false ? true : false,
      tabindex: props.modelValue === false ? "-1" : null
    }));
    const transitionEnd = (event) => {
      if (event.target !== containerRef.value)
        return;
      if (props.modelValue === true) {
        currentHeight.value = null;
        shouldHideOverflow.value = false;
        emit("open-end");
      } else
        emit("close-end");
      isTransitioning.value = false;
    };
    onMounted(() => {
      updateContainerHeight();
      if (!props.modelValue) {
        currentHeight.value = 0;
        shouldHideOverflow.value = true;
      } else {
        currentHeight.value = contentHeight.value + "px";
      }
      if (props.responsive)
        setResizeListener();
      isInit.value = true;
    });
    watch(() => props.modelValue, (v) => {
      updateContainerHeight();
      updateDisplay();
    });
    const resizeCallback = () => {
      if (props.modelValue === false)
        return;
      emit("layout-shift");
      currentHeight.value = contentHeight.value + "px";
      shouldHideOverflow.value = true;
      updateContainerHeight();
      setTimeout(updateDisplay, 0);
    };
    const setResizeListener = () => {
      const observer = new MutationObserver(resizeCallback);
      const config = {
        subtree: true,
        attributes: false,
        childList: true,
        characterData: false
      };
      observer.observe(containerRef.value, config);
    };
    return () => h(props.tag, __spreadProps(__spreadValues(__spreadProps(__spreadValues({}, Object.assign({}, attrs, { style: generatedBaseStyles.value })), {
      class: "slide-up-down__container",
      onTransitionend: transitionEnd
    }), generatedBaseAttributes.value), {
      ref: containerRef
    }), slots.default());
  }
};
const _hoisted_1 = { class: "itlab-app-header" };
const _hoisted_2 = { class: "wrapper" };
const _hoisted_3 = { class: "app-routes" };
const _hoisted_4 = {
  "stroke-linecap": "round",
  "stroke-linejoin": "round",
  fill: "none",
  "fill-rule": "evenodd",
  points: "15 1.13 8.5 7.72 2 1.13"
};
const _hoisted_5 = ["overflow"];
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "itlab-app-header",
  props: {
    breakpoint: { default: 600 }
  },
  setup(__props) {
    let bp = ref(window.matchMedia(`(max-width: ${__props.breakpoint}px)`));
    let mobile = ref(false);
    let overflow = ref(false);
    const overflowWrapper = ref(null);
    const overflowLinks = ref(null);
    const expand = ref(null);
    const collapse = ref(null);
    const transitionDelay = computed(() => {
      if (overflow.value || !mobile.value)
        return 0;
      const slot = useSlots().default;
      if (!slot)
        return 0;
      return slot().length * 100 + 300 + "ms";
    });
    function registerBreakpoint() {
      unregisterBreakpoint();
      bp.value = window.matchMedia(`(max-width: ${__props.breakpoint}px)`);
      bp.value.addEventListener("change", bpEvent);
      mobile.value = bp.value.matches;
    }
    function unregisterBreakpoint() {
      bp.value.removeEventListener("change", bpEvent);
    }
    function bpEvent(e) {
      mobile.value = e && e.matches;
      if (!mobile.value)
        overflow.value = false;
    }
    function enableTrans() {
      overflowWrapper.value.setAttribute(
        "style",
        `--delay: ${transitionDelay.value}`
      );
    }
    function disableTrans() {
      overflowWrapper.value.setAttribute("style", `--delay: 0`);
    }
    function animateLinks(direction) {
      overflowLinks.value.querySelectorAll("a").forEach((el, index2, { length }) => {
        let delay = 0;
        if (direction === "hide")
          delay = index2 * 60;
        else
          delay = (length - index2) * 60 + 250;
        el.classList.remove("appear", "hide");
        el.style.animationDelay = delay + "ms";
        requestAnimationFrame(() => {
          el.classList.add(direction);
        });
      });
    }
    watchEffect(() => {
      registerBreakpoint();
    });
    watch(overflow, () => {
      const elem = overflow.value ? expand.value : collapse.value;
      if (elem)
        elem.beginElement();
    });
    return (_ctx, _cache) => {
      const _component_router_link = resolveComponent("router-link");
      return openBlock(), createElementBlock("nav", _hoisted_1, [
        createElementVNode("div", _hoisted_2, [
          createVNode(_component_router_link, {
            class: "app-title",
            to: { name: "home" }
          }, {
            default: withCtx(() => [
              renderSlot(_ctx.$slots, "title")
            ]),
            _: 3
          }),
          createElementVNode("div", _hoisted_3, [
            !mobile.value ? renderSlot(_ctx.$slots, "default", { key: 0 }) : createCommentVNode("", true),
            _ctx.$slots.default && mobile.value ? (openBlock(), createElementBlock("svg", {
              key: 1,
              onClick: _cache[0] || (_cache[0] = ($event) => overflow.value = !overflow.value),
              class: "expander",
              viewBox: "0 0 17 8.85",
              height: "8.85",
              width: "17"
            }, [
              createElementVNode("polyline", _hoisted_4, [
                createElementVNode("animate", {
                  ref_key: "expand",
                  ref: expand,
                  attributeName: "points",
                  values: "15 1.13 8.5 7.72 2 1.13; 15.85 4.42 8.5 4.42 1.15 4.42; 15 7.72 8.5 1.13 2 7.72",
                  dur: "320ms",
                  begin: "indefinite",
                  fill: "freeze",
                  keyTimes: "0; 0.5; 1",
                  calcMode: "spline",
                  keySplines: "0.12, 0, 0.38, 0; 0.2, 1, 0.68, 1"
                }, null, 512),
                createElementVNode("animate", {
                  ref_key: "collapse",
                  ref: collapse,
                  attributeName: "points",
                  values: "15 7.72 8.5 1.13 2 7.72; 15.85 4.42 8.5 4.42 1.15 4.42; 15 1.13 8.5 7.72 2 1.13",
                  dur: "320ms",
                  begin: "indefinite",
                  fill: "freeze",
                  keyTimes: "0; 0.5; 1",
                  calcMode: "spline",
                  keySplines: "0.2, 0, 0.68, 0; 0.2, 1, 0.68, 1"
                }, null, 512)
              ])
            ])) : createCommentVNode("", true),
            renderSlot(_ctx.$slots, "static")
          ])
        ]),
        createVNode(Transition, { name: "overflow-background" }, {
          default: withCtx(() => [
            overflow.value ? (openBlock(), createElementBlock("div", {
              key: 0,
              class: "overflow-background",
              onClick: _cache[1] || (_cache[1] = withModifiers(($event) => overflow.value = false, ["stop"])),
              onTouchmovePassive: _cache[2] || (_cache[2] = withModifiers(() => {
              }, ["prevent"])),
              onWheelPassive: _cache[3] || (_cache[3] = withModifiers(() => {
              }, ["prevent"])),
              onMousewheelPassive: _cache[4] || (_cache[4] = withModifiers(() => {
              }, ["prevent"])),
              "on:DOMMouseScroll": _cache[5] || (_cache[5] = withModifiers(() => {
              }, ["prevent"]))
            }, null, 32)) : createCommentVNode("", true)
          ]),
          _: 1
        }),
        createElementVNode("div", {
          class: "overflow-wrapper",
          overflow: overflow.value,
          style: normalizeStyle({ "--delay": transitionDelay.value }),
          ref_key: "overflowWrapper",
          ref: overflowWrapper
        }, [
          createVNode(unref(index), {
            modelValue: overflow.value,
            "onUpdate:modelValue": _cache[6] || (_cache[6] = ($event) => overflow.value = $event),
            onOpenStart: _cache[7] || (_cache[7] = ($event) => {
              animateLinks("appear");
              enableTrans();
            }),
            onCloseStart: _cache[8] || (_cache[8] = ($event) => {
              animateLinks("hide");
              enableTrans();
            }),
            onOpenEnd: _cache[9] || (_cache[9] = ($event) => disableTrans()),
            onCloseEnd: _cache[10] || (_cache[10] = ($event) => disableTrans()),
            style: normalizeStyle({ "transition-delay": transitionDelay.value }),
            responsive: true,
            timingFunction: "cubic-bezier(0.075, 0.82, 0.165, 1)"
          }, {
            default: withCtx(() => [
              createElementVNode("div", {
                class: "overflow-container",
                ref_key: "overflowLinks",
                ref: overflowLinks
              }, [
                renderSlot(_ctx.$slots, "default")
              ], 512)
            ]),
            _: 3
          }, 8, ["modelValue", "style"])
        ], 12, _hoisted_5)
      ]);
    };
  }
});
const itlabAppHeader_vue_vue_type_style_index_0_lang = "";
const ITLabAppHeaderPlugin = {
  install(app) {
    app.component("itlab-app-header-button", _sfc_main$1);
    app.component("itlab-app-header", _sfc_main);
  }
};
export {
  _sfc_main as ITLabAppHeader,
  _sfc_main$1 as ITLabAppHeaderButton,
  ITLabAppHeaderPlugin
};
(function(){"use strict";try{if(typeof document!="undefined"){var e=document.createElement("style");e.id="itlab-app-header",e.appendChild(document.createTextNode(".itlab-app-header-button{cursor:pointer;display:flex;justify-content:center;align-items:center;user-select:none;text-decoration:none!important;margin-left:15px;background:var(--lab-primary);color:#fff;border-radius:17.4px;font-size:12px;line-height:1.333333333;padding:4px 11px}.itlab-app-header-button span~svg{margin-left:.5em}.itlab-app-header-button svg~span{margin-left:.5em}.itlab-app-header-button svg{height:.8em;width:.8em;flex-shrink:0}.itlab-app-header{position:sticky;top:0;margin-top:calc(-1*env(safe-area-inset-top));padding-top:env(safe-area-inset-top);color:var(--lab-color);min-height:50px;z-index:100;font-size:14px}.itlab-app-header .wrapper{z-index:101;padding-left:calc(5vw + env(safe-area-inset-left));padding-right:calc(5vw + env(safe-area-inset-right));max-width:1100px;width:calc(90vw - env(safe-area-inset-left) - env(safe-area-inset-right));overflow:auto;margin:0 auto;height:50px;display:flex;justify-content:space-between;align-items:center;position:relative}.itlab-app-header .app-title{text-decoration:none;color:inherit;display:flex;justify-content:center;align-items:center;font-size:16px;font-weight:500}.itlab-app-header .app-title svg{margin-right:.5em;height:1.15em;width:1.15em;flex-shrink:0}.itlab-app-header .expander{cursor:pointer;padding:10px;margin:0 -10px;stroke-width:2;stroke:var(--lab-color-secondary)}.itlab-app-header .app-routes{display:flex;justify-content:flex-end;align-items:center}.itlab-app-header .app-routes a:not(.itlab-app-header-button){text-decoration:none;color:inherit;user-select:none;margin-left:15px}.itlab-app-header .app-routes a:not(.itlab-app-header-button):hover{color:var(--lab-primary)}.itlab-app-header .app-routes a:not(.itlab-app-header-button).router-link-exact-active{color:var(--lab-color-secondary);cursor:default;pointer-events:none}.itlab-app-header .overflow-background{background:rgba(0,0,0,.48);width:100vw;height:100vh;position:absolute}.itlab-app-header .overflow-wrapper{left:0;right:0;padding-top:calc(50px + env(safe-area-inset-top));margin-top:calc(-50px - env(safe-area-inset-top));position:absolute;background:var(--lab-background-opaque);transition:background .5s cubic-bezier(.05,.16,.24,1) var(--delay);scrollbar-width:0;-ms-overflow-style:none}@supports (-webkit-backdrop-filter: initial) or (backdrop-filter: initial){.itlab-app-header .overflow-wrapper{backdrop-filter:saturate(174%) blur(20px);-webkit-backdrop-filter:saturate(174%) blur(20px);background:var(--lab-background-blur)}}.itlab-app-header .overflow-wrapper[overflow=true]{background:var(--lab-background)}.itlab-app-header .overflow-wrapper ::-webkit-scrollbar{display:none}.itlab-app-header .overflow-wrapper .overflow-container{padding-bottom:10px;padding-left:calc(5vw + env(safe-area-inset-left));padding-right:calc(5vw + env(safe-area-inset-right));max-width:1100px;width:calc(90vw - env(safe-area-inset-left) - env(safe-area-inset-right));margin:0 auto;overflow:auto}.itlab-app-header .overflow-wrapper .overflow-container a{display:block;text-decoration:none;color:inherit;user-select:none;font-size:14px;margin:0 1.25em;padding:12.5px 0}.itlab-app-header .overflow-wrapper .overflow-container a:hover{color:var(--lab-primary)}.itlab-app-header .overflow-wrapper .overflow-container a.router-link-exact-active{color:var(--lab-color-secondary);cursor:default;pointer-events:none}.itlab-app-header .overflow-wrapper .overflow-container a:not(:last-child){border-bottom:1px solid var(--lab-border)}.itlab-app-header .overflow-wrapper .overflow-container a.appear{animation:appear .75s cubic-bezier(.075,.82,.165,1) both}.itlab-app-header .overflow-wrapper .overflow-container a.hide{animation:appear .5s cubic-bezier(.075,.82,.165,1) both reverse}@keyframes appear{0%{opacity:0;transform:translateY(-80px)}to{opacity:1;transform:translateY(0)}}.itlab-app-header .overflow-background-enter-from,.itlab-app-header .overflow-background-leave-to{opacity:0}.itlab-app-header .overflow-background-enter-active,.itlab-app-header .overflow-background-leave-active{transition:opacity .5s cubic-bezier(.05,.16,.24,1)}")),document.head.appendChild(e)}}catch(a){console.error("vite-plugin-css-injected-by-js",a)}})();
